---
layout: post
title: 关于对未来手机的想象
tags: [未来, 手机]
---

  我听说洗澡的时候思维最发散（笑）<!--more-->    
  
# 起因
  前两天小米10发布了，看着那最高将近6000CNY的手机我沉默了……   
  昨天我在洗澡的时候正好就在想关于手机的事，手机越来越贵看起来似乎成为了趋势，当然对于小米10Pro来说，它的技术是应该值那样的价钱。但是我觉得这不应该是未来手机的发展，未来的手机绝对不是将越来越多的东西堆到一个砖头大的小盒子里，于是在我洗澡的时候就回想起了以前对未来设备的想象。   
  
# 对手机与性能的看法
  因为以前做过[Telnet BBS](https://github.com/Mabbs/Mabbs)，所以我对Telnet与当时的历史了解的也比较深。我听说以前的电脑算力十分的差，当人们需要计算一些比较复杂的东西就会通过Telnet连接到算力更强的电脑上去计算那些东西。但是随着现在个人电脑的计算能力越来越强，以及对于安全性的需要，Telnet成为了历史的记忆。   
  像我的服务器才1h1g，而现在买到的电脑甚至都可以是几十核，真的是不能比……不过对于手机来说，配置再高的手机，运算能力也完全比不过电脑，毕竟功耗在那里放着，电脑里可以搞一个巨大的风扇，或者是一套复杂的水冷系统。但是手机主要还是便携性，搞一堆复杂的散热系统也不现实，就更不用说供电的问题了。   
  让手机有着更好的性能从这个角度来看似乎是没有意义的，更好的性能要么更耗电，要么就用更好的生产工艺与设计，然而这样会更贵……所以我觉得手机向着更好的性能发展是不合理的发展趋势。   
  综上所述，我觉得可以把手机的算力设计到很低，这样无论从耗电发热还是从成本来说都很低。然后让手机去连接运算能力更强的服务器，在那个上面去运行需要用到运算能力的程序，这样我们就可以去掉手机上所有的散热设备，以及各种各样的附件，用以增大电池的空间，或者让手机更薄。   
  我之所以这样想主要还有一个原因，那就是旧手机的问题。我有一部5年前的华为麦芒4，它的CPU是骁龙616的，算力十分垃圾，被淘汰是应该的。但是它的屏幕是1080P的屏幕，和我目前使用的红米K20Pro的屏幕像素密度差不多（虽然材质不一样）。即使到现在，大多数的旗舰机也都使用的是1080P的屏幕。既然如此，这个屏幕还是完好无损且同样更得上时代的情况下仅仅是因为处理器过时了就被时代淘汰了，不是显得浪费吗？   

# 未来的手机：云手机
  所以我想了一种新的手机设计方案，那就是云手机。虽然云手机的理念提出了很长时间，但是不知道为什么出的都是为电脑工作的云手机，而不是真正为手机服务的云手机。或者说仅仅做为单独的应用使用的云手机，比如云存储还是什么云服务啥的……总而言之，目前的云手机完全没有融入使用者的生活，仅仅是作为一种辅助。   
  如果说可以制造一种手机，主要的成本全部在屏幕和电池上，然后这个手机在没有联网时唯一能做的就是打电话，而联网时连接到远程服务器上就可以像正常的手机一样上网聊天打游戏，所有的操作全部由服务器进行运算，然后通过远程桌面的协议在手机上进行表达。   
  现在的远程桌面协议已经很多了，像什么VNC、RDP还有什么SPICE，所以说我觉得从技术上来说，服务器负责运行程序，而手机只负责控制与显示，这样手机也不再耗电，可能充一次可以用个两三天，在打游戏时也不再发烫和卡顿（网络原因除外），而且也可以根据自己的需要得到相应的配置，价格也会更加便宜。   
## 设计内容
  1. 关于服务器的配置   
    现在的虚拟化技术也非常成熟了，什么弹性计算之类的也做的很不错了。像大多数时候当人们不再使用手机的时候手机事实上是在空载状态的，最多就是聊天信息需要随时到达。那么大多数情况我们的手机可能只需要一核CPU就可以满足需要，对于ARM的CPU，一核的运行成本应该很低吧？而在人们打游戏的时候需要的更多核服务器也可以想提供多少就能提供多少吧？而且这个还能挂机。那么我们就可以进行定价，比如手机平时使用一核，突发性使用四核，这个成本也没多高，1天1CNY应该也不亏吧？或者根据实际使用计算价格，一年下来可能也就花个400CNY左右吧？这也不算贵嘛，正常买一部高性能手机也要花2000-3000CNY吧？但是实际用个2-3年也就淘汰了嘛。   
  2. 关于手机的设计   
    现在的手机主要成本屏幕占的应该也不算太多，换个屏幕也就300-400CNY左右吧？我觉得主要成本应该还是在主板上。但是如果说这个主板除了联网打电话，加个定位和WiFi，顺便来个5MP能扫码的后摄应该也没多贵吧？200CNY总能拿下吧？想拍照为啥不买微单呢？电池就更不用说了，200CNY买个4000mAh的电池应该轻轻松松吧？700CNY出一个超长待机，屏幕又大又清晰的手机即使对于山寨机来说都是轻轻松松吧？700CNY的手机如果说加上每年400CNY的云手机费用性能能和目前4000CNY的手机相比那我觉得还是挺划算的吧？   

  最终成本也不高，消费者也能负担的起，然后服务商也能持续从消费者那里拿钱，岂不美哉？

# 附加的优点
  我们也不一定只提供Android系统，同样如果有必要也可以提供Windows系统，顺便卖个没有运算能力的平板和电脑盒子，系统可以互相相互连接，在平板上既可以操作手机的系统，随时也可以操作电脑的系统，两个系统硬盘可以相互访问，也就没必要再导来导去的了。毕竟这时候手机、平板、电脑都成为了真正意义的终端，一切服务都在服务器上完成。   
  还有一个优点，这时候终端的网速将不再重要，重要的是与服务器连接的稳定性，服务器本身的带宽自然是超级大，毕竟连的都是光纤，延迟也极其的小，实际的延迟在于终端操作与服务器的延迟上，不过我觉得随着现在网络的发展，家里的延迟由WiFi6去缩小，家外的延迟由5G去缩小，最终一定能得到与原生一般的操作体验。   
  
# 我的计划
  如果说在我大三的时候这样的手机还没有出现在市场上，我就有了创业的冲动（突然理解了为什么大学生想出去创业），想办法去拉众筹、投资与贷款，然后看看自己能不能搞到人脉，去和华强北的大佬们一起研发出这样的手机23333   
  如果真的能造出这样的手机以及这样的服务，我觉得一定会有市场的。
