---
layout: post
title: 对于云手机的策划书
tags: [手机, 策划]
---

  策划？不存在的！<!--more-->   

# 前言
  我写了[对未来手机的想象](/2020/02/15/phone.html)这篇文章之后，突然想起来学校最近搞了一个创新比赛，反正在家里也是闲着，就打算和同学一起参考我的文章搞一下。   
  不过我只对写我的博客感兴趣，对写像什么调查之类乱七八糟的东西没什么兴趣，然后我就把策划书的大部分内容交给了那个同学，自己就主要写一下大概的方向。   
  当然作为人来说，他看起来也对写这种东西不怎么感兴趣，瞎编一部分又从网上找了些资料，写了一半就打算就这么交差。不过其实我对这个东西也没抱多大期望，就当给延长的假期找个乐子吧。   
  那么接下来就是主要内容了：
  
# 一、执行总结
## 一、概念产品概述
  远程云手机(Remote Cloud Phone，简称“RCP”)是基于远程控制与虚拟化技术的移动通讯设备，该产品运用云计算与5G技术提高了资源的利用率，大大降低了手机的生产成本和实际运算成本。   
  该产品主要分为两部分，一部分是价格低廉，且有着强大续航能力的控制与显示终端，另一部分是计算力强大，且无需考虑电能消耗的远程云计算平台。   
  控制与显示终端利用5G的低延时和高效的传输来尽可能的模拟真实手机的使用效果，由于计算不在本地，所以本地设备的电能消耗和发热都可以做到相当低。远程云计算平台使用虚拟化技术进行动态的弹性计算，既能提高能效比，又可以提高实际的运算能力。由于远程云计算完全不需要考虑发热量和电能消耗，所以也可以提供无限的计算能力。   
## 二、面临的市场机会和目标市场定位
市场机会：   
外部环境：随着手机科技含量的逐步提高，导致手机价格不断上涨，人民群众对于高科技手机日渐增长的需求与手机不断增长的价格产生了矛盾，人们需要一种价格相对较低，又能满足需求的较高性能的手机。   
内部环境：虚拟化技术与远程服务器已经成熟，并且这两项也是云手机的实现最为重要的技术。   
目标市场定位：由于手机市场还未有完整成熟的云手机产业链，所以应该先占据市场金字塔的中层，依靠成本低的优势开拓市场。针对于云手机现在的状况，应该采用无差异营销战略，集中研发中端产品。   
## 三、市场环境与竞争优势
市场环境：目前，多家公司已经迈进了“云手机”大门，瞄准了“云端”，共同发力智能手机市场。但仍没有做到彻底意义上的云手机，云手机的市场尚未达到饱和，仍有发展潜力   
竞争优势：云手机比起普通智能手机，有几处非常大的优势。   
1. 存储优势：云手机本身没有存储功能，所有存储都将“云存储”在服务器中，节省了普通智能手机中的内存条空间。
2. 价格优势：云手机几乎所有的计算与渲染工作全部交给了远程服务器，因此云手机产品主要关注于云手机的外观、屏幕分辨率、摄像头分辨率、电池容量，少了许多硬件的安装，手机成本自然降低。
3. 电量持久性优势：手机由于少了许多硬件的安装，手机内部空间变大，可以安装更大容量的电池，并且由于“云手机”在真正工作时，只起到显示的作用，因此电量持续时间可以更久，不会由于工作太久而发热，不影响用户操作体验。
4. 网速更快：由于所有的计算与渲染工作全部交给了远程服务器，远程服务器的运算速度肯定是大于手机本身的，所以可以提高网速，带给用户极致体验。

## 四、团队概述
团队分为四块主体：营销、策划、技术人员和生产。   
技术与生产是最为困难的部分。技术人员主要依靠招聘相关专业高素质人才，生产项目依托给华强北，营销策划另外招聘相关专业人员。   
## 五、经济状况和盈利能力预测
创业初期资金紧张，主要依靠企业投资和创始者资金众筹。   
由于云手机概念并未普及，前期需要进行大量宣传，资金主要花在了研发、广告宣传、服务器等设备的购买上。企业前几个季度必然是亏损为主，但后几个季度会趋之平稳，待云手机的优势宣传普及民众，必然会有更多的消费者购买。   
## 六、所需资源和所提供的利益
企业的经首先营需要资金支持，人才资源支持、场地支持   
云手机两大核心技术是虚拟机技术与远程服务器技术，需要购买服务器，因为安卓在ARM指令集运行效率最高，所以最好买ARM指令集的服务器。   
由于手机的原本功能都由服务计算，不需要在手机中再安装过多芯片所以能为制造手机商减少硬件安装成本。服务器集群，可以在服务器空闲状态出售空闲算力，获得资金，还可以进行品牌宣传。   

# 二、产业背景和市场竞争
产业背景：目前，多家公司已经迈进了“云手机”大门，瞄准了“云端”，共同发力智能手机市场。但仍没有做到彻底意义上的云手机，云手机的市场尚未达到饱和，仍有巨大的发展潜力。手机科技含量逐步提高，导致手机价格不断上涨，中低端消费者对于高科技手机的需求日渐增长，但手机价格不断增长，人们需要一种价格相对较低，又能满足需求的较高性能的手机。   
市场竞争环境:   
多家公司迈进了“云手机”大门。   
苹果先行一步，基于原有的MobileMe功能全新改写而成的苹果iCloud服务iCloud正式对全球的苹果开发者开放。   
国内的手机厂家也不甘落后，阿里巴巴、小米、腾讯纷纷开始发力。2011年8月，阿里巴巴推出的“阿里云”手机介入智能手机市场。手机系统是自主研发“云智能OS”，采用Cloud App方式，用户无需在手机端下载应用，只要在网络环境下登陆统一的云账号就可以运行OS平台上的各种应用，如阿里浏览器、阿里搜索、手机旺旺等。腾讯已经和华为合作推出了包含19款QQ应用的手机，其和中国电信深度定制的手机QPhone操作系统也在加快面世的速度。小米更是发布首台智能手机以攻城略地。   
2011年9月，百度和戴尔也瞄准了“云端”，共同发力智能手机市场。2011百度世界大会上，百度创始人兼CEO李彦宏就流传已久的“百度手机”透露了相关信息。“我们应该已经跟一家国际手机厂商达成了协议”。最终中国搜索引擎巨头百度将携手全球第二大PC制造厂商戴尔公司共同开发智能手机以及平板电脑。双方合作的手机产品预计将于11月—12月期间上市销售。与此同时，百度在本次大会上还发布了移动终端操作系统“百度易”，并开始向第三方开发商抛出橄榄枝。不难看出，百度进军移动互联网领域的目标正在有条不紊的进行着。   
与此同时不少厂商还瞄准了老人手机市场，其中2012年3月国内首款云老人手机由沃爱思推出。其将云服务功能用于老人手机，实现了子女远程即可操作控制父母手机的全新体验。只需轻松通过web端，即可达到子女身边电脑和父母的沃爱思云服务手机之间的连接，内容变更、设置设定等就可以变成一件没有距离的事情。可以为老人进手机的所有设置，可以远程管理设置：远程定位、健康资料、联系人、图铃、闹钟、桌布时间与日期、键盘、高级设置、手机模式等菜单功能。   

# 三、市场调查和分析
## 一、目标市场的定位与分析
云手机尚未普及，可以凭借其成本低价格低的优势，获得中低端消费者的青睐，具体的目标群体应该是高中生大学生，这类消费者消费能力处于中高端水准，并且有较高的素质，弄够理解云手机的概念并更好的使用云手机的相关功能。根据调查报告显示，大学生对手机要求最重要的是运行速度，占34%;其次是功能全面，占29%；在往下是价格便宜，占18%；当然外观漂亮也是重要的，占14%；其余的要求占4%。云手机依靠远程服务器拥有运行速度的优势，能够很好地满足消费者需求。
## 二、市场容量估算和趋势预测
由于云手机概念产品并未正式上市，所以其市场容量估算和趋势预测只能依靠2009-2018年智能手机的市场容量估算和趋势去进行参考，云手机的出现将是与智能手机的出现一样具有跨时代革命意义的，所以云手机的发展趋势可以拿智能手机这些年的发展作为一个参考。   
近几年，中国智能手机行业蓬勃发展，手机更新换代频繁，手机产量持续增长。2016年手机产量达到最高峰，共计22.61亿部。2018年1-11月手机产量为16.41亿部，同比下降2.4%。预计2019年手机产量降幅或扩大。   
手机市场趋向于存量状态，国内手机市场国产品牌迅速崛起。国内手机存量市场份额最大的仍然是苹果，占比28.90%，华为占比17.10%；国产品牌手机近年来占比持续上升，华为在2018年的市场占有率达到26.39%，OPPO和Vivo占比达到将近40%。中国巨大的市场需求给中国本土手机品牌的崛起增添了更多的筹码，国内分销市场代理国内品牌的比例普遍上升。   
5G将带来新一轮换机潮。基于作为移动互联入口的智能手机与人类生活深度融合，5G手机有望开启智能手机的高速物联时代。5G作为第五代移动通信网络，相比于4G网络来说，其最高理论传输速度可达数10Gb/秒，快了将近数百倍，一部完整超高清画质的电影可在一秒内下载完成。预计2019年5G智能手机出货量占智能手机出货量总额的0.5%，整体智能手机出货量在下降，但是5G智能手机预计到2023年有望超过4亿台，市占率达到26%。   
经过十多年高速发展，中国手机市场接近饱和状态，虽然全面屏、AI等技术带动了手机行业的发展，但在5G到来之前，这些技术还不足以带来大面积的换机需求。而在国际上的一些新兴市场，依然存在增长红利。   
华为目前在欧洲、中东、非洲和印度市场都加快脚步；受益于中国和印度市场出货量大增，小米成为2018年全球增速最快的手机品牌之一，除了印度之外，目前其加速发力西班牙、俄罗斯、欧洲等市场。   
## 三、竞争格局分析和竞争优势
三星在2019年全球智能手机出货量市场占份额为21.6%；华为在2019年全球智能手机出货量市场份额为17.6%位居第二；苹果市场占份额为13.9%。小米出货量为1.256亿台，占市场份额为9.2%；OPPO出货量为1.143亿台，占市场份额为8.3%。值得一提的是，前五大手机厂商市场份额超全球智能手机市场份额的7成。   
在一个竞争如此激烈的市场存活绝非易事，需要有过人的竞争优势。云手机概念产品最大的优势便是其续航能力，因为云手机本身只负责接收和显示，耗电量并不大，估算续航能力是普通手机的3-4倍。并且计算和渲染在服务器中进行，所以处理速度也是可以令消费者满意的。   
## 四、估计的市场份额和销售额
2019年全球智能手机出货量为13.71亿部，同比下降2.3%。全球智能手机出货量连续第三年下滑。 从手机厂商来看，2019年，三星、华为、苹果、小米、OPPO出货量排名前五位，出货量分别为2.96亿部、2.41亿部、1.91亿部、1.26亿部、1.14亿部。2019年，尽管华为在海外市场面临持续挑战，但仍超越了苹果成为智能手机出货量全球第二。未来，伴随着网络覆盖率提高、5G提速，中国消费者仍在等待更加亲民的5G智能手机面市。   
## 五、市场发展的趋势
智能机行业呈现平缓发展状态，2018年市场规模达到15.6亿台，同比增长9.4%，随着人口红利枯竭，智能机市场增长动力主要依靠迭代换新。   
苹果在国内的市场首席地位并未被超越，但以华为、oppo和vivo为首的国产阵营品牌抓住科技机遇和换机红利，不断扩大市场空间，而小米、三星、魅族等品牌则有锁缩水。   
智能手机迭代需求弥补人口红利动力减弱的损失，通过更富科技感和时尚感的产品设计和定位，激发人们的换机心理，推动市场向更高层次发展。   
一、二线城市以及东部沿海地区引领高端智能机市场，三、四线、五线城市以及华中、西南、西北等内陆地区则不断升级设备，其中定位中端的智能机较受欢迎。   
一线城市智能移动终端市场新增乏力，二线城市是新增智能移动终端主要市场，新增设备以高端机为主流，三线及以下城市的增幅更加明显，中端机更加受到用户亲睐。   
智能移动终端质量方面整体提升明显，电池、屏幕等主要故障问题逐步减少，但是，内存不足问题有所升温；智能移动终端维修渠道目前主要依赖官方售后和传统线下门店。   
根据上面数据可得几个结论：   
1. 智能机市场增长动力主要依靠迭代换新。
2. 需要更富科技感和时尚感的产品才能促进迭代换新。
3. 定位中端的智能机较受欢迎。
4. 二、三线城市是新增智能移动终端主要市场。
5. 内存不足问题有所升温。

从以上结论中发现云手机概念产品是适合当下市场的消费者需求与大环境发展趋势的   
云手机概念产品的提出，可以有力的促进迭代换新，从而从接近饱和的市场中再次开拓新的市场。并且云手机消费群众定位在中端消费者与二三线城市，且中端消费者的市场还未饱和，仍有开拓潜力。云手机本身优势可以很好地解决内存、手机发热、价格过高的问题。   

# 四、公司战略
## 一、商业模式
关键业务： 统一通信、通信设备、云计算与云服务   
核心资源： 创新的技术、人才资源、顾客信息   
价值主张： 以提高人们生活质量为愿景，运用云计算科学与技术领域专业,缩小贫富差距， 让人人享有。以绿色科学为基本准则，应对全球变暖挑战，资源集群化，减少能源浪费，创造更佳的社会效益，经济效益。   
顾客关系： 以顾客和市场为中心。 与客户结为战略合作伙伴，以双赢为发展目标。以及时挖掘顾客需求作为企业发展动力；以客户不断增长的需求作为企业存在的意义。   
销售渠道： 分销渠道，直销渠道。   
售后服务： 设置对应的客户群经理、区域客户代表，了解客户需求，满足客户需求。确保及时响应。设有服务热线，顾客可以直接通过拨打热线来反映需求，其需求将由专人转达给相关人员，最后再反馈给客户。成本结构：研发成本、采购成本、生产成本、无形成本   
收入来源：通信设备占主要，云计算与云服务占次要。其中主要为通信设备购买、云端软件购买、服务器空闲资源出租   
## 二、公司的研发方向和产品线扩张策略
公司研发方向主要是设计产品外观、服务器群的搭建、最重要的事开发、优化远程连接服务器与手机的软件   
产品线扩张策略：在概念产品基本研制完毕的基础上，第一季度主要搭建服务器群组，第二季度进入设备测验、调试、生产阶段，并进行策划宣传。第三季度正式投入市场。每两个季度推出一款优化过的云手机。优化主要是针对设备运行速度。   
## 三、主要的合作伙伴与竞争对手等
主要的合作伙伴是生产商、宣传商、设备及其零件提供商。   
主要对手是例如像华为、苹果这样已经在云手机方面有开发经验和已经开始研发的厂商。   

# 五、关键的风险和问题
## 一、技术方面
可能存在实际产品的网络稳定性无法达到预期，或使用效果无法和原机相比。   
这部分可以通过向更可能提供稳定网络区域的消费者宣传，比如上班族等使用范围始终在稳定区域的人们
## 二、市场方面
可能出现消费者不信任等问题。   
这个解决方案可以通过提高宣传预期来降低人们对这个产品的不信任。
## 三、财务方面
可能存在初期成本无法回收等问题。   
可以通过众筹等方式融资。

# 后记
  我在这个活动结束之后，仔细思考了一下我的这个产品的的实用性。   
  我看了一下现在更多人买手机的方案，发现我的产品还是有很多地方是有缺陷的。先不论技术问题，对于消费者来说，现在分期消费已经很流行了，比如一台5000CNY的手机，如果可以免息分期24期，每月也才200CNY左右，而过了两年之后也差不多该换新的手机了，这时候再来一波以旧换新，5000CNY的手机2年后顶1000CNY应该没问题吧？然后第三年换个更好的手机，在不考虑通货膨胀等情况下再分期……这样算下来其实价格也没多高，然后相比于云手机的稳定性又会高很多…… ~~（感觉老考虑这种事的我是不是穷疯了？23333）~~   
  不过如果真的有云手机出现，说不定以后终端设备包年免费送，结果最后又回到现在需要一次付清的尴尬情况23333   
  感觉生活就像是正弦函数一般，不断在前进，但是又不断在重复，感觉进步毫无意义，但是又不能不做……   
  不过对于我来说，我还是挺希望云手机的出现，因为我觉得云手机更符合手机的意义，堆配置不应该是手机该做的事，那是电脑该做的，手机还是应该做好它便携高效的本职才对。

