---
layout: post
title: 在平板上使用Termux的经历
tags: [Termux, Android]
---

  更好的利用闲置的设备吧！<!--more-->    

# 起因
  在去年，我的同学买了一块Android的平板电脑，因为我的专业主要需要使用Linux系统，平时学习也需要用到电脑，所以也是想做一个实验想验证一下Android系统的平板能不能在一定程度上替代电脑。虽然笔记本电脑不算很重，但是如果说平板就能替代笔记本电脑，那么使用的时候也会更加方便吧，而且平板的续航一般也比笔记本电脑好，我觉得如果实验能成功，其实做一个这样的方案也不错。   
  我手头也正好有些闲置的平板，不过去年因为在Alpha实验阶段，所以我平时上课还是用的电脑。最终对同学进行经过一年左右的测试，我感觉这个方案是个不错的选择，而且随着ARM服务器的盛行，也不需要担心软件包因为架构的原因不能用的问题。   

# 方案
  最开始我是想着绝大多数情况下使用远程桌面应该是个不错的选择，平板作为瘦客户机是个非常好的选择，不过在实际的实验中发现，使用这种方式对网络的要求很高，就像我之前[玩云游戏](/2021/09/28/cloudgame.html)那样，很多时候很考验心态，动不动就会卡，包括使用SSH的方案也差不多，虽然SSH可能对网络的要求更小一点，但是问题在于SSH连接的假如是内网服务器，需要看一些Web项目的效果会很麻烦。所以在最终我选定了Termux来作为实际实验的方案。   
  最终体验效果还是挺不错的，平时使用各种需要的东西基本上都不受限制，比如Python、Django、Jupyter、Ansible之类的，只要是电脑上Linux能装的软件，Termux都可以装，而且运行效果也还不错，这也多亏了那些ARM服务器和树莓派对ARM的大力支持。不过有时候一些定制化的系统导致的一些限制也比较烦，国内的定制系统很多对后台程序限制很严格，而且一般屏幕一关掉程序就没法执行了，导致某些情况下体验不是很好，不过还好绝大多数情况这些限制都是可以调整的，用的话还是可以用的。   
  接下来我打算把实验推到Beta阶段，在这个阶段我打算用上我闲置的平板，验证各种情况下使用平板来进行各种操作。   

# 对旧设备的兼容性调整
  我同学使用的是新买的平板电脑，Android的版本也比较高，另外处理器也是ARM架构的，但是我的平板不是新的，闲置的平板Android版本也比较低，处理器还是个X86架构的，这导致我在一些操作中和同学的操作不一样。    
  从Termux v0.73开始，它的Android兼容性要求变成了Android 7.0+，可是我的平板是Android 5.0的，所以我只好下载Termux v0.72用。不过这个这个版本用的时候问题好像还挺多的，最开始我为了下载包快一些换了源，但是不知道为什么用国内镜像源怎么都会出错，下载的包会直接没法运行，后来没办法就只能用官方源。不过官方源也会出点问题，在`/etc/apt/source.list.d/`中有一些已经炸掉的源，在执行`apt update`之前要把这里面所有的文件都删掉，另外删掉之后执行`apt upgrade`之后那个文件夹里面的文件又会出现，所以还得再删一次。   
  不过用官方源也不是办法，在国内用还是速度慢，而且Termux的源里面软件也比较少，所以想了想还是装Linux发行版比较好。不过旧版的Termux不像新版那样可以安装proot-distro，直接一键安装Linux发行版，旧版要想用只能用AnLinux安装。结果AnLinux也还有些问题，他们把资源都保存到Github上了，但是Github在国内下载raw是完全没办法的，结果我就只能在电脑上提前在[AnLinux资源仓库](https://github.com/EXALAB/Anlinux-Resources)里面下载好需要的脚本和镜像，然后再传到平板上进行安装。   
  在安装了发行版之后，换源安装软件就不会再出问题了，在那个上面可以随便安装最新的软件包。我安装了一套Python和Jupyter都可以正常运行，接下来如果可以的话就让我试试看平板使用Termux效果如何吧。   

# 增强性改动
  我的平板没有物理键盘，然后输入法上也没有上下左右键，导致我操作的时候很麻烦，后来我在网上查了一下，只要运行   
```shell
mkdir ~/.termux && echo "extra-keys = [['ESC','/','-','HOME','UP','END','PGUP'],['TAB','CTRL','ALT','LEFT','DOWN','RIGHT','PGDN']]" > ~/.termux/termux.properties
```
  然后重启Termux就可以在键盘上方出现需要的大多数按键，感觉效果还不错。

# 总结
  其实这也是更好利用旧设备的方案，之前我也有写过[怎样更好的利用旧手机](/2020/03/08/oldphone.html)，现在如果用了Termux效果就更好了，之前想要安装Web环境用的还是KSWEB的方案，现在的话想安什么环境就和操作电脑和服务器一样简单了。无论如何旧设备还是用起来更好，闲置确实就毫无意义了，不如回收掉或者换盆啥的。
